#include <stdlib.h>
#include <dlfcn.h>
#include <lauxlib.h>

#include "model.h"

model_t *model_new(const char *lib_path, lua_State *L) {
    model_t *M = calloc(1, sizeof(model_t));

    M->handle = dlopen(lib_path, RTLD_LAZY);

    void *(*new) (lua_State *) = dlsym(M->handle, "new");
    M->del = dlsym(M->handle, "del");
    M->dump = dlsym(M->handle, "dump");
    M->step = dlsym(M->handle, "step");

    M->_ = new(L);

    return M;
}

void model_del(model_t *M) {
    M->del(M->_);
    dlclose(M->handle);
    free(M);
}

void model_dump(model_t *M, int i) {
    M->dump(M->_, i);
}

void model_step(model_t *M, int i) {
    M->step(M->_, i);
}
